//---------------------------------------------------------------------------

#ifndef FormSettingsH
#define FormSettingsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
#include "Settings.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>

#include <vector>

class TfrmAccount;
class TfrmHotkeys;
class TfrmPhones;

class TfrmSettings : public TForm
{
__published:	// IDE-managed Components
	TPanel *pnlBottom;
	TButton *btnCancel;
	TButton *btnApply;
	TPageControl *pcGeneral;
	TTabSheet *tsGeneral;
	TTabSheet *tsLogging;
	TCheckBox *chbAlwaysOnTop;
	TLabel *lblUiCapacity;
	TComboBox *cmbMaxUiLogLines;
	TCheckBox *chbLogToFile;
	TTabSheet *tsAccounts;
	TPanel *pnlAccountsBottom;
	TButton *btnAddAccount;
	TScrollBox *scrbAccounts;
	TCheckBox *chbLogMessages;
	TTabSheet *tsCodecs;
	TCheckBox *chbG711;
	TCheckBox *chbSpeex;
	TCheckBox *chbGsm;
	TCheckBox *chbG726_32;
	TLabel *lblLocalAddress;
	TEdit *edLocalAddress;
	TTabSheet *tsCalls;
	TLabel *lblSipAutoAnswerCode;
	TEdit *edAutoAnswerCode;
	TTabSheet *tsAudioIO;
	TLabel *lblSoundInputModule;
	TComboBox *cbSoundInputMod;
	TLabel *lblAudioInput;
	TLabel *lblSoundInputDevice;
	TComboBox *cbSoundInputDev;
	TLabel *lblAudioOutput;
	TLabel *Label3;
	TLabel *Label4;
	TComboBox *cbSoundOutputMod;
	TComboBox *cbSoundOutputDev;
	TLabel *lblAudioAlertOutput;
	TLabel *Label6;
	TLabel *Label7;
	TComboBox *cbSoundAlertOutputMod;
	TComboBox *cbSoundAlertOutputDev;
	TCheckBox *chbStartMinimizedToTray;
	TTabSheet *tsAEC;
	TLabel *lblAec;
	TComboBox *cbAec;
	TLabel *lblWebRtcAec;
	TLabel *Label1;
	TLabel *lblWebRtcAecClockSkew;
	TEdit *edWebRtcAecMsInSndCardBuf;
	TEdit *edWebRtcAecSkew;
	TCheckBox *chbTrayNotifierShowOnIncoming;
	TCheckBox *chbSkipTrayNotifierIfMainWindowVisible;
	TLabel *lblAutoAnswerDelay;
	TEdit *edAutoAnswerDelayMin;
	TLabel *lblAutoAnswerDelayMin;
	TEdit *edAutoAnswerDelayMax;
	TLabel *lblAutoAnswerDelayMax;
	TLabel *lblGuiScaling;
	TEdit *edGuiScaling;
	TLabel *lblGuiScalingPct;
	TCheckBox *chbAutoAnswer;
	TCheckBox *chbAutoAnswerCallInfo;
	TLabel *lblAudioOutputIntercom;
	TLabel *Label2;
	TLabel *Label5;
	TComboBox *cbSoundOutputIntercomMod;
	TComboBox *cbSoundOutputIntercomDev;
	TLabel *lblAutoAnswerCallInfoDelayMin;
	TEdit *edAutoAnswerCallInfoDelayMin;
	TTabSheet *tsIntegration;
	TCheckBox *chAddFilterWMCopyData;
	TButton *btnCreateIntegrationProtocol;
	TLabel *lblProtocolName;
	TEdit *edProtocolName;
	TLabel *lblProtoInfo1;
	TLabel *lblProtoInfo2;
	TTabSheet *tsRing;
	TLabel *lblRingDefault;
	TEdit *edRingDefault;
	TButton *btnRingSelectDefault;
	TLabel *lblRingBellcoreDr1;
	TEdit *edRingBellcoreDr1;
	TButton *btnRingSelectBellcoreDr1;
	TLabel *lblRingBellcoreDr2;
	TEdit *edRingBellcoreDr2;
	TButton *btnRingSelectBellcoreDr2;
	TLabel *lblRingBellcoreDr3;
	TEdit *edRingBellcoreDr3;
	TButton *btnRingSelectBellcoreDr3;
	TLabel *lblRingBellcoreDr4;
	TEdit *edRingBellcoreDr4;
	TButton *btnRingSelectBellcoreDr4;
	TLabel *lblRingBellcoreDr5;
	TEdit *edRingBellcoreDr5;
	TButton *btnRingSelectBellcoreDr5;
	TLabel *lblRingBellcoreDr6;
	TEdit *edRingBellcoreDr6;
	TButton *btnRingSelectBellcoreDr6;
	TLabel *lblRingBellcoreDr7;
	TEdit *edRingBellcoreDr7;
	TButton *btnRingSelectBellcoreDr7;
	TLabel *lblRingBellcoreDr8;
	TEdit *edRingBellcoreDr8;
	TButton *btnRingSelectBellcoreDr8;
	TOpenDialog *dlgOpenRing;
	TCheckBox *chbXBtnMinimize;
	TTabSheet *tsHotkeys;
	TTabSheet *tsContacts;
	TCheckBox *chbContactPopupShowOnIncoming;
	TCheckBox *chbContactPopupShowOnOutgoing;
	TLabel *lblContactPopup;
	TTabSheet *tsRecording;
	TCheckBox *chbRecordingEnabled;
	TTabSheet *tsSpeedDial;
	TLabel *lblSpeedDial;
	TComboBox *cbSpeedDialSize;
	TLabel *lblSpeedDialColumnWidth;
	TEdit *edSpeedDialColumnWidth;
	TCheckBox *chbShowSpeedDialOnly;
	TCheckBox *chbRestoreMainWindowOnIncomingCall;
	TCheckBox *chbTrayNotifierShowOnOutgoing;
	TTabSheet *tsPhones;
	TLabel *lblRecDirType;
	TComboBox *cbRecDirType;
	TLabel *lblCustomRecDir;
	TEdit *edCustomRecDir;
	TButton *btnSelectCustomRecDir;
	TLabel *lblContactHttpQuery;
	TEdit *edContactHttpQuery;
	TLabel *lblRtpPortRange;
	TLabel *lblRtpPortMin;
	TEdit *edRtpPortMin;
	TLabel *lblRtpPortMax;
	TEdit *edRtpPortMax;
	TLabel *lblRecordingMode;
	TComboBox *cbRecordingChannels;
	TButton *btnSelectWaveFile;
	TEdit *edSoundInputWave;
	TCheckBox *chbSingleInstance;
	TCheckBox *chbAnswerOnEventTalk;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall btnCancelClick(TObject *Sender);
	void __fastcall btnApplyClick(TObject *Sender);
	void __fastcall btnAddAccountClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall cbSoundInputModChange(TObject *Sender);
	void __fastcall cbSoundOutputModChange(TObject *Sender);
	void __fastcall cbSoundAlertOutputModChange(TObject *Sender);
	void __fastcall cbSoundOutputIntercomModChange(TObject *Sender);
	void __fastcall btnCreateIntegrationProtocolClick(TObject *Sender);
	void __fastcall btnRingSelectClick(TObject *Sender);
	void __fastcall FormKeyPress(TObject *Sender, char &Key);
	void __fastcall cbRecDirTypeChange(TObject *Sender);
	void __fastcall btnSelectCustomRecDirClick(TObject *Sender);
	void __fastcall btnSelectWaveFileClick(TObject *Sender);
private:	// User declarations
	std::vector<TfrmAccount*> frmAccountVector;
	void FillDevList(TComboBox *target, int module, bool out, AnsiString selected);
	TfrmHotkeys *frmHotkeys;
	TfrmPhones *frmPhones;
public:		// User declarations
	__fastcall TfrmSettings(TComponent* Owner);
	Settings tmpSettings;
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmSettings *frmSettings;
//---------------------------------------------------------------------------
#endif
